/*----------------------------------------------------------------------
time-stamp: <02/07/25 12:52:03 kawasan>
Time-stamp: <02/07/30 21:17:09 kawasan>

TrevaXilinxJTAG饤ͳLinuxɤ߼

ƻϡʲͤˤ롣
$ treva | convert - pict.png

  ----------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <time.h>
#include <sys/io.h>
#include <asm/ioctl.h>


#define PICT_XSIZE ( 96 )
#define PICT_YSIZE ( 72 )
#define PICT_DATA_SIZE ( PICT_XSIZE * PICT_YSIZE * 2 )


//#define WAIT_EN
#ifdef WAIT_EN
#define IO_WAIT ( 0x80 )
#define IO_WAIT_SIZE ( 1 )
#define WAIT_1US outb( 0, IO_WAIT )
#else
#define WAIT_1US
#endif


//#define IO_PORT ( 0x278 )
#define IO_PORT ( 0x378 )
#define IO_PORT_SIZE ( 8 )
#define IO_PORT_DATA ( IO_PORT + 0 )	// ǡBUS D7..0
#define IO_PORT_STAT ( IO_PORT + 1 )	// /BUSY /ACK PE SLCT /Error NA NA NA
#define IO_PORT_CTRL ( IO_PORT + 2 )	// NA NA NA IRQ_En SLCT /INIT AUTO_FD_XT STROBE_Pulse


void treva_clk( int dat )
{
    if ( dat ) {
	/* CLK = 1 */
	outb( 0x12, IO_PORT_DATA );
    } else {
	/* CLK = 0 */
	outb( 0x10, IO_PORT_DATA );
    }
}
 
int treva_data( void )
{
    return inb( IO_PORT_STAT ) & 0x10 ? 1 : 0;
}
 
void treva_close( void )
{
    ioperm( IO_PORT, IO_PORT_SIZE, 0 );
#ifdef WAIT_EN
    ioperm( IO_WAIT, IO_WAIT_SIZE, 0 );
#endif
}


void treva_init( void )
{
#ifdef WAIT_EN
    if ( ioperm( IO_WAIT, IO_WAIT_SIZE, 1 ) != 0 ) {
	fprintf( stderr, "Cannot Access I/O Ports.\n" );
	exit( 1 );
    }
#endif

    if ( ioperm( IO_PORT, IO_PORT_SIZE, 1 ) != 0 ) {
	fprintf( stderr, "Cannot Access I/O Ports.\n" );
	exit( 1 );
    }
    outb( 0x0a, IO_PORT_CTRL );

    /* check Xilinx-JTAG-Write-Board */
    outb( 0x10, IO_PORT_DATA ); /* 0001_0000B */
    WAIT_1US;
    //printf( "PRN = %02X\n", inb( IO_PORT_STAT ) );
    if ( ( inb( IO_PORT_STAT ) & 0x20 ) != 0 ) {
	fprintf( stderr, "Cannot Access Xilinx-JTAG-Write-Board(1).\n" );
	treva_close();
	exit( 1 );
    }
    outb( 0x50, IO_PORT_DATA ); /* 0101_0000B */
    WAIT_1US;
    //printf( "PRN = %02X\n", inb( IO_PORT_STAT ) );
    if ( ( inb( IO_PORT_STAT ) & 0x20 ) == 0 ) {
	fprintf( stderr, "Cannot Access Xilinx-JTAG-Write-Board(2).\n" );
	treva_close();
	exit( 1 );
    }
}


/* 1bitɤ߽Ф */
int read_bit( void )
{
    int dat;

    /* CLK = 0 */
    treva_clk( 0 );
    WAIT_1US;

    /* Ω夬DOUTɤ߹ */
    dat = treva_data();

    /* CLK = 1 */
    treva_clk( 1 );
    WAIT_1US;

    return dat;
}


/* ǡѴ ( YUV  PPM ) */
int yuv2ppm( unsigned char *img )
{
    int cnt1;
    int cnt2;
    int pnt;
    int dat_y, dat_u, dat_v;
    int dat_r, dat_g, dat_b;

    printf( "P6\n" );
    printf( "%d %d %d ", PICT_XSIZE, PICT_YSIZE, 255 );

    for ( cnt1 = 0; cnt1 < PICT_YSIZE; cnt1 ++ ) {
	for ( cnt2 = 0; cnt2 < PICT_XSIZE; cnt2 ++ ) {
	    pnt = ( cnt1 * PICT_XSIZE + cnt2 ) * 2;
	    dat_y = img[ pnt + 1 ];
	    if ( cnt2 % 2 == 0 ) {
		dat_v = img[ pnt ];
		dat_u = img[ pnt + 2 ];
	    } else {
		dat_v = img[ pnt - 2 ];
		dat_u = img[ pnt ];
	    }

	    dat_u = dat_u - 128.0;
	    dat_v = dat_v - 128.0;

	    /* YUVRGBؤѴ */
	    dat_r = dat_u + dat_y;
	    dat_g = 0.98 * dat_y - 0.53 * dat_u - 0.19 * dat_v;
	    dat_b = dat_v + dat_y;

	    if ( dat_r > 255 ) dat_r = 255;
	    if ( dat_r < 0 ) dat_r = 0;
	    if ( dat_g > 255 ) dat_g = 255;
	    if ( dat_g < 0 ) dat_g = 0;
	    if ( dat_b > 255 ) dat_b = 255;
	    if ( dat_b < 0 ) dat_b = 0;

	    /* ǡν */
	    printf( "%c", (unsigned char)dat_r );
	    printf( "%c", (unsigned char)dat_g );
	    printf( "%c", (unsigned char)dat_b );
	}
    }

    return 0;
}


int main( int argc, char *argv[] )
{
    int cnt1, cnt2;
    unsigned char dat;
    unsigned char yuv[ PICT_DATA_SIZE ];

    treva_init();

    /* 100bitϢ³'1'ΤԤ */
    cnt1 = 0;
    while ( cnt1 < 100 ) {
	if( read_bit() == 1 ) {
	    cnt1 ++;
	} else {
	    cnt1 = 0;
	}
    }
		
    /* Ϣ³65bitʬ'0'򸡽 */
    cnt1 = 0;
    while ( cnt1 < 65 ) {
	if( read_bit() == 0 ) {
	    cnt1 ++;
	} else {
	    cnt1 = 0;
	}
    }

    /* ³16bitʬΥǡ̵ */
    for( cnt1 = 0; cnt1 < 16; cnt1 ++ ) {
	read_bit();
    }
		
    /* ǡ */
    for( cnt1 = 0; cnt1 < PICT_DATA_SIZE; cnt1 ++ ) {
	dat = 0;
	for ( cnt2 = 0; cnt2 < 8; cnt2 ++ ) {
	    dat <<= 1;
	    if ( read_bit() ) {
		dat |= 0x1;
	    }
	}

	yuv[ cnt1 ] = dat;

	/* ǡɸϤ */
	//putchar( dat );
    }

    /* ǡѴ */
    yuv2ppm( yuv );

    return 0;
}
